summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--sys-cluster/openmpi/Manifest1
-rw-r--r--sys-cluster/openmpi/openmpi-3.0.1.ebuild171
2 files changed, 172 insertions, 0 deletions
diff --git a/sys-cluster/openmpi/Manifest b/sys-cluster/openmpi/Manifest
index 9c8565ff813..5312125db61 100644
--- a/sys-cluster/openmpi/Manifest
+++ b/sys-cluster/openmpi/Manifest
@@ -10,3 +10,4 @@ DIST openmpi-2.0.2.tar.bz2 8311215 BLAKE2B 8dd0d7b95c396e9a0f05760136bbf62defd35
DIST openmpi-2.0.4.tar.bz2 8272983 BLAKE2B 7d0a392fbc8c896cdccefb9bf0ff83fbd8db8a42d17f06cb23ac88ba896e2c75e1b1b7a79559d0ce3c2b881f197f54ce1bd8967c889bafe2b97f95fb6b957501 SHA512 2cccb83847d44f6282ec24f7bc12ab51b84dc5ac1a2a919ef0761847ff7cdcb31cfb1f38dca33df7063a98c27a64575a108002716d207cbba3a54773b999e6c5
DIST openmpi-2.1.3.tar.bz2 8311304 BLAKE2B a6a2d0d759a7207e4e9e9bb1526825ce5b0c9acd22c113f71712381fd7cab55228e78294533a5af6ef2b243803d789c5c71c6d59dd7a8ebbf10b2aa5d99296fd SHA512 61ecf53d840feb4cad1e792225c7fb07a8c4cb849f21693051359cde2cf1b5060de3a9d00ba3b55ded20b5b93bc5ac439951b4fe5cb1a74d4e800f26c979feba
DIST openmpi-3.0.0.tar.bz2 9267606 BLAKE2B 9ee569a9c5f5918bb3d389a2945a2e7a5d98464afbd111eb2426a4e8296a23cf6d5b558554ce8126b13f910bd59acbb77e93ac297f3cf222c4bc764836b39ee6 SHA512 7e37eacf959a803d6d89dff4291b64a1f3d83bc7941b778a2fb13d12be0f205cb904e4a807d79676ad1e31fd99ffb15f255c8a227e830673455abb144f14616a
+DIST openmpi-3.0.1.tar.bz2 9176460 BLAKE2B 65fdaeb492da3cf86a68c2d47d19568c8d65e92d0202041853ae3cbe0f057d8bdc79953538921b5b8c9eb9c9cedab8502816985e12524704992069a51e08d857 SHA512 15fad504ba743d564e7196b62a112027798d4b26e9c8d11d9c1c00ac2968f1858ebc168df30473104c5a31f71e38ab558204b598260b535a12b6094aa77182b8
diff --git a/sys-cluster/openmpi/openmpi-3.0.1.ebuild b/sys-cluster/openmpi/openmpi-3.0.1.ebuild
new file mode 100644
index 00000000000..6393b65d02e
--- /dev/null
+++ b/sys-cluster/openmpi/openmpi-3.0.1.ebuild
@@ -0,0 +1,171 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+FORTRAN_NEEDED=fortran
+
+inherit cuda flag-o-matic fortran-2 java-pkg-opt-2 toolchain-funcs versionator multilib-minimal
+
+MY_P=${P/-mpi}
+S=${WORKDIR}/${MY_P}
+
+IUSE_OPENMPI_FABRICS="
+ openmpi_fabrics_ofed
+ openmpi_fabrics_knem
+ openmpi_fabrics_psm"
+
+IUSE_OPENMPI_RM="
+ openmpi_rm_pbs
+ openmpi_rm_slurm"
+
+IUSE_OPENMPI_OFED_FEATURES="
+ openmpi_ofed_features_control-hdr-padding
+ openmpi_ofed_features_udcm
+ openmpi_ofed_features_rdmacm
+ openmpi_ofed_features_dynamic-sl"
+
+DESCRIPTION="A high-performance message passing library (MPI)"
+HOMEPAGE="http://www.open-mpi.org"
+SRC_URI="http://www.open-mpi.org/software/ompi/v$(get_version_component_range 1-2)/downloads/${MY_P}.tar.bz2"
+LICENSE="BSD"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~ia64 ~ppc ~ppc64 ~sparc ~x86 ~amd64-linux"
+IUSE="cma cuda cxx elibc_FreeBSD fortran heterogeneous ipv6 java numa romio
+ ${IUSE_OPENMPI_FABRICS} ${IUSE_OPENMPI_RM} ${IUSE_OPENMPI_OFED_FEATURES}"
+
+REQUIRED_USE="openmpi_rm_slurm? ( !openmpi_rm_pbs )
+ openmpi_rm_pbs? ( !openmpi_rm_slurm )
+ openmpi_fabrics_psm? ( openmpi_fabrics_ofed )
+ openmpi_ofed_features_control-hdr-padding? ( openmpi_fabrics_ofed )
+ openmpi_ofed_features_udcm? ( openmpi_fabrics_ofed )
+ openmpi_ofed_features_rdmacm? ( openmpi_fabrics_ofed )
+ openmpi_ofed_features_dynamic-sl? ( openmpi_fabrics_ofed )"
+
+# dev-util/nvidia-cuda-toolkit is always multilib
+CDEPEND="
+ !sys-cluster/mpich
+ !sys-cluster/mpich2
+ !sys-cluster/nullmpi
+ !sys-cluster/mpiexec
+ >=dev-libs/libevent-2.0.22[${MULTILIB_USEDEP},threads]
+ dev-libs/libltdl:0[${MULTILIB_USEDEP}]
+ >=sys-apps/hwloc-1.11.2[${MULTILIB_USEDEP},numa?]
+ >=sys-libs/zlib-1.2.8-r1[${MULTILIB_USEDEP}]
+ cuda? ( >=dev-util/nvidia-cuda-toolkit-6.5.19-r1 )
+ elibc_FreeBSD? ( || ( dev-libs/libexecinfo >=sys-freebsd/freebsd-lib-10.0 ) )
+ openmpi_fabrics_ofed? ( sys-fabric/ofed:* )
+ openmpi_fabrics_knem? ( sys-cluster/knem )
+ openmpi_fabrics_psm? ( sys-fabric/infinipath-psm:* )
+ openmpi_rm_pbs? ( sys-cluster/torque )
+ openmpi_rm_slurm? ( sys-cluster/slurm )
+ openmpi_ofed_features_rdmacm? ( sys-fabric/librdmacm:* )"
+
+RDEPEND="${CDEPEND}
+ java? ( >=virtual/jre-1.6 )"
+
+DEPEND="${CDEPEND}
+ java? ( >=virtual/jdk-1.6 )"
+
+MULTILIB_WRAPPED_HEADERS=(
+ /usr/include/mpi.h
+ /usr/include/openmpi/ompi/mpi/java/mpiJava.h
+)
+
+pkg_setup() {
+ fortran-2_pkg_setup
+ java-pkg-opt-2_pkg_setup
+
+ elog
+ elog "OpenMPI has an overwhelming count of configuration options."
+ elog "Don't forget the EXTRA_ECONF environment variable can let you"
+ elog "specify configure options if you find them necessary."
+ elog
+}
+
+src_prepare() {
+ default
+
+ # Necessary for scalibility, see
+ # http://www.open-mpi.org/community/lists/users/2008/09/6514.php
+ echo 'oob_tcp_listen_mode = listen_thread' \
+ >> opal/etc/openmpi-mca-params.conf || die
+}
+
+multilib_src_configure() {
+ if use java; then
+ # We must always build with the right -source and -target
+ # flags. Passing flags to javac isn't explicitly supported here
+ # but we can cheat by overriding the configure test for javac.
+ export ac_cv_path_JAVAC="$(java-pkg_get-javac) $(java-pkg_javac-args)"
+ fi
+
+ ECONF_SOURCE=${S} econf \
+ --sysconfdir="${EPREFIX}/etc/${PN}" \
+ --enable-pretty-print-stacktrace \
+ --enable-orterun-prefix-by-default \
+ --with-hwloc="${EPREFIX}/usr" \
+ --with-libltdl="${EPREFIX}/usr" \
+ --with-libevent="${EPREFIX}/usr" \
+ --enable-mpi-fortran=$(usex fortran all no) \
+ $(use_enable cxx mpi-cxx) \
+ $(use_with cma) \
+ $(use_with cuda cuda "${EPREFIX}"/opt/cuda) \
+ $(use_enable romio io-romio) \
+ $(use_enable heterogeneous) \
+ $(use_enable ipv6) \
+ $(multilib_native_use_enable java) \
+ $(multilib_native_use_enable java mpi-java) \
+ $(multilib_native_use_with openmpi_fabrics_ofed verbs "${EPREFIX}"/usr) \
+ $(multilib_native_use_with openmpi_fabrics_knem knem "${EPREFIX}"/usr) \
+ $(multilib_native_use_with openmpi_fabrics_psm psm "${EPREFIX}"/usr) \
+ $(multilib_native_use_enable openmpi_ofed_features_control-hdr-padding openib-control-hdr-padding) \
+ $(multilib_native_use_enable openmpi_ofed_features_rdmacm openib-rdmacm) \
+ $(multilib_native_use_enable openmpi_ofed_features_udcm openib-udcm) \
+ $(multilib_native_use_enable openmpi_ofed_features_dynamic-sl openib-dynamic-sl) \
+ $(multilib_native_use_with openmpi_rm_pbs tm) \
+ $(multilib_native_use_with openmpi_rm_slurm slurm)
+}
+
+multilib_src_test() {
+ # Doesn't work with the default src_test as the dry run (-n) fails.
+ emake -j1 check
+}
+
+multilib_src_install() {
+ default
+
+ # fortran header cannot be wrapped (bug #540508), workaround part 1
+ if multilib_is_native_abi && use fortran; then
+ mkdir "${T}"/fortran || die
+ mv "${ED}"usr/include/mpif* "${T}"/fortran || die
+ else
+ # some fortran files get installed unconditionally
+ rm \
+ "${ED}"usr/include/mpif* \
+ "${ED}"usr/bin/mpif* \
+ "${ED}"usr/bin/oshfort \
+ "${ED}"usr/bin/shmemfort \
+ || die
+ fi
+}
+
+multilib_src_install_all() {
+ # fortran header cannot be wrapped (bug #540508), workaround part 2
+ if use fortran; then
+ mv "${T}"/fortran/mpif* "${ED}"usr/include || die
+ fi
+
+ # Remove la files, no static libs are installed and we have pkg-config
+ find "${ED}" -name '*.la' -delete || die
+
+ if use java; then
+ local mpi_jar="${ED}"usr/$(get_libdir)/mpi.jar
+ java-pkg_dojar "${mpi_jar}"
+ # We don't want to install the jar file twice
+ # so let's clean after ourselves.
+ rm "${mpi_jar}" || die
+ fi
+
+ einstalldocs
+}